- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# CoinFactorization Class Reference

This deals with Factorization and Updates. More...

`#include <CoinFactorization.hpp>`

Collaboration diagram for CoinFactorization:

[legend]
List of all members.

## used by factorization
void | getAreas (int numberRows, int numberColumns, CoinBigIndex maximumL, CoinBigIndex maximumU)
| Gets space for a factorization, called by constructors.
void | preProcess (int state, int possibleDuplicates=-1)
| PreProcesses raw triplet data.
int | factor ()
| Does most of factorization.
int | replaceColumnPFI (CoinIndexedVector *regionSparse, int pivotRow, double alpha)
| Replaces one Column to basis for PFI returns 0=OK, 1=Probably OK, 2=singular, 3=no room.
int | factorSparse ()
| Does sparse phase of factorization return code is <0 error, 0= finished.
int | factorSparseSmall ()
| Does sparse phase of factorization (for smaller problems) return code is <0 error, 0= finished.
int | factorSparseLarge ()
| Does sparse phase of factorization (for larger problems) return code is <0 error, 0= finished.
int | factorDense ()
| Does dense phase of factorization return code is <0 error, 0= finished.
bool | pivotOneOtherRow (int pivotRow, int pivotColumn)
| Pivots when just one other row so faster?
bool | pivotRowSingleton (int pivotRow, int pivotColumn)
| Does one pivot on Row Singleton in factorization.
bool | pivotColumnSingleton (int pivotRow, int pivotColumn)
| Does one pivot on Column Singleton in factorization.
bool | getColumnSpace (int iColumn, int extraNeeded)
| Gets space for one Column with given length, may have to do compression (returns True if successful), also moves existing vector, extraNeeded is over and above present.
bool | reorderU ()
| Reorders U so contiguous and in order (if there is space) Returns true if it could.
bool | getColumnSpaceIterateR (int iColumn, double value, int iRow)
| getColumnSpaceIterateR.
CoinBigIndex | getColumnSpaceIterate (int iColumn, double value, int iRow)
| getColumnSpaceIterate.
bool | getRowSpace (int iRow, int extraNeeded)
| Gets space for one Row with given length, may have to do compression (returns True if successful), also moves existing vector.
bool | getRowSpaceIterate (int iRow, int extraNeeded)
| Gets space for one Row with given length while iterating, may have to do compression (returns True if successful), also moves existing vector.
void | checkConsistency ()
| Checks that row and column copies look OK.
void | addLink (int index, int count)
| Adds a link in chain of equal counts.
void | deleteLink (int index)
| Deletes a link in chain of equal counts.
void | separateLinks (int count, bool rowsFirst)
| Separate out links with same row/column count.
void | cleanup ()
| Cleans up at end of factorization.
void | updateColumnL (CoinIndexedVector *region, int *indexIn) const
| Updates part of column (FTRANL).
void | updateColumnLDensish (CoinIndexedVector *region, int *indexIn) const
| Updates part of column (FTRANL) when densish.
void | updateColumnLSparse (CoinIndexedVector *region, int *indexIn) const
| Updates part of column (FTRANL) when sparse.
void | updateColumnLSparsish (CoinIndexedVector *region, int *indexIn) const
| Updates part of column (FTRANL) when sparsish.
void | updateColumnR (CoinIndexedVector *region) const
| Updates part of column (FTRANR) without FT update.
void | updateColumnRFT (CoinIndexedVector *region, int *indexIn)
| Updates part of column (FTRANR) with FT update.
void | updateColumnU (CoinIndexedVector *region, int *indexIn) const
| Updates part of column (FTRANU).
void | updateColumnUSparse (CoinIndexedVector *regionSparse, int *indexIn) const
| Updates part of column (FTRANU) when sparse.
void | updateColumnUSparsish (CoinIndexedVector *regionSparse, int *indexIn) const
| Updates part of column (FTRANU) when sparsish.
int | updateColumnUDensish (double *COIN_RESTRICT region, int *COIN_RESTRICT regionIndex) const
| Updates part of column (FTRANU).
void | updateTwoColumnsUDensish (int &numberNonZero1, double *COIN_RESTRICT region1, int *COIN_RESTRICT index1, int &numberNonZero2, double *COIN_RESTRICT region2, int *COIN_RESTRICT index2) const
| Updates part of 2 columns (FTRANU) real work.
void | updateColumnPFI (CoinIndexedVector *regionSparse) const
| Updates part of column PFI (FTRAN) (after rest).
void | permuteBack (CoinIndexedVector *regionSparse, CoinIndexedVector *outVector) const
| Permutes back at end of updateColumn.
void | updateColumnTransposePFI (CoinIndexedVector *region) const
| Updates part of column transpose PFI (BTRAN) (before rest).
void | updateColumnTransposeU (CoinIndexedVector *region, int smallestIndex) const
| Updates part of column transpose (BTRANU), assumes index is sorted i.e.
void | updateColumnTransposeUSparsish (CoinIndexedVector *region, int smallestIndex) const
| Updates part of column transpose (BTRANU) when sparsish, assumes index is sorted i.e.
void | updateColumnTransposeUDensish (CoinIndexedVector *region, int smallestIndex) const
| Updates part of column transpose (BTRANU) when densish, assumes index is sorted i.e.
void | updateColumnTransposeUSparse (CoinIndexedVector *region) const
| Updates part of column transpose (BTRANU) when sparse, assumes index is sorted i.e.
void | updateColumnTransposeUByColumn (CoinIndexedVector *region, int smallestIndex) const
| Updates part of column transpose (BTRANU) by column assumes index is sorted i.e.
void | updateColumnTransposeR (CoinIndexedVector *region) const
| Updates part of column transpose (BTRANR).
void | updateColumnTransposeRDensish (CoinIndexedVector *region) const
| Updates part of column transpose (BTRANR) when dense.
void | updateColumnTransposeRSparse (CoinIndexedVector *region) const
| Updates part of column transpose (BTRANR) when sparse.
void | updateColumnTransposeL (CoinIndexedVector *region) const
| Updates part of column transpose (BTRANL).
void | updateColumnTransposeLDensish (CoinIndexedVector *region) const
| Updates part of column transpose (BTRANL) when densish by column.
void | updateColumnTransposeLByRow (CoinIndexedVector *region) const
| Updates part of column transpose (BTRANL) when densish by row.
void | updateColumnTransposeLSparsish (CoinIndexedVector *region) const
| Updates part of column transpose (BTRANL) when sparsish by row.
void | updateColumnTransposeLSparse (CoinIndexedVector *region) const
| Updates part of column transpose (BTRANL) when sparse (by Row).
int | checkPivot (double saveFromU, double oldPivot) const
| Returns accuracy status of replaceColumn returns 0=OK, 1=Probably OK, 2=singular.
template<class T>
bool | pivot (int pivotRow, int pivotColumn, CoinBigIndex pivotRowPosition, CoinBigIndex pivotColumnPosition, CoinFactorizationDouble work[], unsigned int workArea2[], int increment2, T markRow[], int largeInteger)
| Gets space for a factorization, called by constructors.
## Public Member Functions
Constructors and destructor and copy
| CoinFactorization ()
| Default constructor.
| CoinFactorization (const CoinFactorization &other)
| Copy constructor.
| ~CoinFactorization ()
| Destructor.
void | almostDestructor ()
| Delete all stuff (leaves as after CoinFactorization()).
void | show_self () const
| Debug show object (shows one representation).
int | saveFactorization (const char *file) const
| Debug - save on file - 0 if no error.
int | restoreFactorization (const char *file, bool factor=false)
| Debug - restore from file - 0 if no error on file.
void | sort () const
| Debug - sort so can compare.
CoinFactorization & | operator= (const CoinFactorization &other)
| = copy
Do factorization
int | factorize (const CoinPackedMatrix &matrix, int rowIsBasic[], int columnIsBasic[], double areaFactor=0.0)
| When part of LP - given by basic variables.
int | factorize (int numberRows, int numberColumns, CoinBigIndex numberElements, CoinBigIndex maximumL, CoinBigIndex maximumU, const int indicesRow[], const int indicesColumn[], const double elements[], int permutation[], double areaFactor=0.0)
| When given as triplets.
int | factorizePart1 (int numberRows, int numberColumns, CoinBigIndex estimateNumberElements, int *indicesRow[], int *indicesColumn[], CoinFactorizationDouble *elements[], double areaFactor=0.0)
| Two part version for maximum flexibility This part creates arrays for user to fill.
int | factorizePart2 (int permutation[], int exactNumberElements)
| This is part two of factorization Arrays belong to factorization and were returned by part 1 If status okay, permutation has pivot rows - this is only needed If status is singular, then basic variables have pivot row and ones thrown out have -1 returns 0 -okay, -1 singular, -99 memory.
double | conditionNumber () const
| Condition number - product of pivots after factorization.
general stuff such as permutation or status
int | status () const
| Returns status.
void | setStatus (int value)
| Sets status.
int | pivots () const
| Returns number of pivots since factorization.
void | setPivots (int value)
| Sets number of pivots since factorization.
int * | permute () const
| Returns address of permute region.
int * | pivotColumn () const
| Returns address of pivotColumn region (also used for permuting).
CoinFactorizationDouble * | pivotRegion () const
| Returns address of pivot region.
int * | permuteBack () const
| Returns address of permuteBack region.
int * | pivotColumnBack () const
| Returns address of pivotColumnBack region (also used for permuting) Now uses firstCount to save memory allocation.
CoinBigIndex * | startRowL () const
| Start of each row in L.
CoinBigIndex * | startColumnL () const
| Start of each column in L.
int * | indexColumnL () const
| Index of column in row for L.
int * | indexRowL () const
| Row indices of L.
CoinFactorizationDouble * | elementByRowL () const
| Elements in L (row copy).
int | numberRowsExtra () const
| Number of Rows after iterating.
void | setNumberRows (int value)
| Set number of Rows after factorization.
int | numberRows () const
| Number of Rows after factorization.
CoinBigIndex | numberL () const
| Number in L.
CoinBigIndex | baseL () const
| Base of L.
int | maximumRowsExtra () const
| Maximum of Rows after iterating.
int | numberColumns () const
| Total number of columns in factorization.
int | numberElements () const
| Total number of elements in factorization.
int | numberForrestTomlin () const
| Length of FT vector.
int | numberGoodColumns () const
| Number of good columns in factorization.
double | areaFactor () const
| Whether larger areas needed.
void | areaFactor (double value)
| Returns status.
double | adjustedAreaFactor () const
| Returns areaFactor but adjusted for dense.
void | relaxAccuracyCheck (double value)
| Allows change of pivot accuracy check 1.0 == none >1.0 relaxed.
double | getAccuracyCheck () const
| Returns status.
int | messageLevel () const
| Level of detail of messages.
void | messageLevel (int value)
| Returns status.
int | maximumPivots () const
| Maximum number of pivots between factorizations.
void | maximumPivots (int value)
| Returns status.
int | denseThreshold () const
| Gets dense threshold.
void | setDenseThreshold (int value)
| Sets dense threshold.
double | pivotTolerance () const
| Pivot tolerance.
void | pivotTolerance (double value)
| Returns status.
double | zeroTolerance () const
| Zero tolerance.
void | zeroTolerance (double value)
| Returns status.
double | slackValue () const
| Whether slack value is +1 or -1.
void | slackValue (double value)
| Returns status.
double | maximumCoefficient () const
| Returns maximum absolute value in factorization.
bool | forrestTomlin () const
| true if Forrest Tomlin update, false if PFI
void | setForrestTomlin (bool value)
| Returns status.
bool | spaceForForrestTomlin () const
| True if FT update and space.
some simple stuff
int | numberDense () const
| Returns number of dense rows.
CoinBigIndex | numberElementsU () const
| Returns number in U area.
void | setNumberElementsU (CoinBigIndex value)
| Setss number in U area.
CoinBigIndex | lengthAreaU () const
| Returns length of U area.
CoinBigIndex | numberElementsL () const
| Returns number in L area.
CoinBigIndex | lengthAreaL () const
| Returns length of L area.
CoinBigIndex | numberElementsR () const
| Returns number in R area.
CoinBigIndex | numberCompressions () const
| Number of compressions done.
int * | numberInRow () const
| Number of entries in each row.
int * | numberInColumn () const
| Number of entries in each column.
CoinFactorizationDouble * | elementU () const
| Elements of U.
int * | indexRowU () const
| Row indices of U.
CoinBigIndex * | startColumnU () const
| Start of each column in U.
int | maximumColumnsExtra ()
| Maximum number of Columns after iterating.
int | biasLU () const
| L to U bias 0 - U bias, 1 - some U bias, 2 some L bias, 3 L bias.
void | setBiasLU (int value)
| Returns number of dense rows.
int | persistenceFlag () const
| Array persistence flag If 0 then as now (delete/new) 1 then only do arrays if bigger needed 2 as 1 but give a bit extra if bigger needed.
void | setPersistenceFlag (int value)
| Returns number of dense rows.
rank one updates which do exist
int | replaceColumn (CoinIndexedVector *regionSparse, int pivotRow, double pivotCheck, bool checkBeforeModifying=false, double acceptablePivot=1.0e-8)
| Replaces one Column to basis, returns 0=OK, 1=Probably OK, 2=singular, 3=no room If checkBeforeModifying is true will do all accuracy checks before modifying factorization.
void | replaceColumnU (CoinIndexedVector *regionSparse, CoinBigIndex *deleted, int internalPivotRow)
| Combines BtranU and delete elements If deleted is NULL then delete elements otherwise store where elements are.
various uses of factorization (return code number elements)
which user may want to know about
int | updateColumnFT (CoinIndexedVector *regionSparse, CoinIndexedVector *regionSparse2)
| Updates one column (FTRAN) from regionSparse2 Tries to do FT update number returned is negative if no room regionSparse starts as zero and is zero at end.
int | updateColumn (CoinIndexedVector *regionSparse, CoinIndexedVector *regionSparse2, bool noPermute=false) const
| This version has same effect as above with FTUpdate==false so number returned is always >=0.
int | updateTwoColumnsFT (CoinIndexedVector *regionSparse1, CoinIndexedVector *regionSparse2, CoinIndexedVector *regionSparse3, bool noPermuteRegion3=false)
| Updates one column (FTRAN) from region2 Tries to do FT update number returned is negative if no room.
int | updateColumnTranspose (CoinIndexedVector *regionSparse, CoinIndexedVector *regionSparse2) const
| Updates one column (BTRAN) from regionSparse2 regionSparse starts as zero and is zero at end Note - if regionSparse2 packed on input - will be packed on output.
void | goSparse ()
| makes a row copy of L for speed and to allow very sparse problems
int | sparseThreshold () const
| get sparse threshold
void | sparseThreshold (int value)
| set sparse threshold
various uses of factorization (return code number elements)
which user may not want to know about (left over from my LP code)
void | clearArrays ()
| Get rid of all memory.
various updates - none of which have been written!
int | add (CoinBigIndex numberElements, int indicesRow[], int indicesColumn[], double elements[])
| Adds given elements to Basis and updates factorization, can increase size of basis.
int | addColumn (CoinBigIndex numberElements, int indicesRow[], double elements[])
| Adds one Column to basis, can increase size of basis.
int | addRow (CoinBigIndex numberElements, int indicesColumn[], double elements[])
| Adds one Row to basis, can increase size of basis.
int | deleteColumn (int Row)
| Deletes one Column from basis, returns rank.
int | deleteRow (int Row)
| Deletes one Row from basis, returns rank.
int | replaceRow (int whichRow, int numberElements, const int indicesColumn[], const double elements[])
| Replaces one Row in basis, At present assumes just a singleton on row is in basis returns 0=OK, 1=Probably OK, 2=singular, 3 no space.
void | emptyRows (int numberToEmpty, const int which[])
| Takes out all entries for given rows.
used by ClpFactorization
void | checkSparse ()
| See if worth going sparse.
bool | collectStatistics () const
| For statistics.
void | setCollectStatistics (bool onOff) const
| For statistics.
void | gutsOfDestructor (int type=1)
| The real work of constructors etc 0 just scalars, 1 bit normal.
void | gutsOfInitialize (int type)
| 1 bit - tolerances etc, 2 more, 4 dummy arrays
void | gutsOfCopy (const CoinFactorization &other)
| See if worth going sparse.
void | resetStatistics ()
| Reset all sparsity etc statistics.
## Protected Attributes
data
double | pivotTolerance_
| Pivot tolerance.
double | zeroTolerance_
| Zero tolerance.
double | slackValue_
| Whether slack value is +1 or -1.
double | areaFactor_
| How much to multiply areas by.
double | relaxCheck_
| Relax check on accuracy in replaceColumn.
int | numberRows_
| Number of Rows in factorization.
int | numberRowsExtra_
| Number of Rows after iterating.
int | maximumRowsExtra_
| Maximum number of Rows after iterating.
int | numberColumns_
| Number of Columns in factorization.
int | numberColumnsExtra_
| Number of Columns after iterating.
int | maximumColumnsExtra_
| Maximum number of Columns after iterating.
int | numberGoodU_
| Number factorized in U (not row singletons).
int | numberGoodL_
| Number factorized in L.
int | maximumPivots_
| Maximum number of pivots before factorization.
int | numberPivots_
| Number pivots since last factorization.
CoinBigIndex | totalElements_
| Number of elements in U (to go) or while iterating total overall.
CoinBigIndex | factorElements_
| Number of elements after factorization.
CoinIntArrayWithLength | pivotColumn_
| Pivot order for each Column.
CoinIntArrayWithLength | permute_
| Permutation vector for pivot row order.
CoinIntArrayWithLength | permuteBack_
| DePermutation vector for pivot row order.
CoinIntArrayWithLength | pivotColumnBack_
| Inverse Pivot order for each Column.
int | status_
| Status of factorization.
int | numberTrials_
| Number of trials before rejection.
CoinBigIndexArrayWithLength | startRowU_
| Start of each Row as pointer.
CoinIntArrayWithLength | numberInRow_
| Number in each Row.
CoinIntArrayWithLength | numberInColumn_
| Number in each Column.
CoinIntArrayWithLength | numberInColumnPlus_
| Number in each Column including pivoted.
CoinIntArrayWithLength | firstCount_
| First Row/Column with count of k, can tell which by offset - Rows then Columns.
CoinIntArrayWithLength | nextCount_
| Next Row/Column with count.
CoinIntArrayWithLength | lastCount_
| Previous Row/Column with count.
CoinIntArrayWithLength | nextColumn_
| Next Column in memory order.
CoinIntArrayWithLength | lastColumn_
| Previous Column in memory order.
CoinIntArrayWithLength | nextRow_
| Next Row in memory order.
CoinIntArrayWithLength | lastRow_
| Previous Row in memory order.
CoinIntArrayWithLength | saveColumn_
| Columns left to do in a single pivot.
CoinIntArrayWithLength | markRow_
| Marks rows to be updated.
int | messageLevel_
| Detail in messages.
int | biggerDimension_
| Larger of row and column size.
CoinIntArrayWithLength | indexColumnU_
| Base address for U (may change).
CoinIntArrayWithLength | pivotRowL_
| Pivots for L.
CoinFactorizationDoubleArrayWithLength | pivotRegion_
| Inverses of pivot values.
int | numberSlacks_
| Number of slacks at beginning of U.
int | numberU_
| Number in U.
CoinBigIndex | maximumU_
| Maximum space used in U.
CoinBigIndex | lengthU_
| Length of U.
CoinBigIndex | lengthAreaU_
| Length of area reserved for U.
CoinFactorizationDoubleArrayWithLength | elementU_
| Elements of U.
CoinIntArrayWithLength | indexRowU_
| Row indices of U.
CoinBigIndexArrayWithLength | startColumnU_
| Start of each column in U.
CoinBigIndexArrayWithLength | convertRowToColumnU_
| Converts rows to columns in U.
CoinBigIndex | numberL_
| Number in L.
CoinBigIndex | baseL_
| Base of L.
CoinBigIndex | lengthL_
| Length of L.
CoinBigIndex | lengthAreaL_
| Length of area reserved for L.
CoinFactorizationDoubleArrayWithLength | elementL_
| Elements of L.
CoinIntArrayWithLength | indexRowL_
| Row indices of L.
CoinBigIndexArrayWithLength | startColumnL_
| Start of each column in L.
bool | doForrestTomlin_
| true if Forrest Tomlin update, false if PFI
int | numberR_
| Number in R.
CoinBigIndex | lengthR_
| Length of R stuff.
CoinBigIndex | lengthAreaR_
| length of area reserved for R
CoinFactorizationDouble * | elementR_
| Elements of R.
int * | indexRowR_
| Row indices for R.
CoinBigIndexArrayWithLength | startColumnR_
| Start of columns for R.
double * | denseArea_
| Dense area.
int * | densePermute_
| Dense permutation.
int | numberDense_
| Number of dense rows.
int | denseThreshold_
| Dense threshold.
CoinFactorizationDoubleArrayWithLength | workArea_
| First work area.
CoinUnsignedIntArrayWithLength | workArea2_
| Second work area.
CoinBigIndex | numberCompressions_
| Number of compressions done.
double | ftranCountInput_
| Below are all to collect.
double | ftranCountAfterL_
| Pivot tolerance.
double | ftranCountAfterR_
| Pivot tolerance.
double | ftranCountAfterU_
| Pivot tolerance.
double | btranCountInput_
| Pivot tolerance.
double | btranCountAfterU_
| Pivot tolerance.
double | btranCountAfterR_
| Pivot tolerance.
double | btranCountAfterL_
| Pivot tolerance.
int | numberFtranCounts_
| We can roll over factorizations.
int | numberBtranCounts_
| Pivot tolerance.
double | ftranAverageAfterL_
| While these are average ratios collected over last period.
double | ftranAverageAfterR_
| Pivot tolerance.
double | ftranAverageAfterU_
| Pivot tolerance.
double | btranAverageAfterU_
| Pivot tolerance.
double | btranAverageAfterR_
| Pivot tolerance.
double | btranAverageAfterL_
| Pivot tolerance.
bool | collectStatistics_
| For statistics.
int | sparseThreshold_
| Below this use sparse technology - if 0 then no L row copy.
int | sparseThreshold2_
| And one for "sparsish".
CoinBigIndexArrayWithLength | startRowL_
| Start of each row in L.
CoinIntArrayWithLength | indexColumnL_
| Index of column in row for L.
CoinFactorizationDoubleArrayWithLength | elementByRowL_
| Elements in L (row copy).
CoinIntArrayWithLength | sparse_
| Sparse regions.
int | biasLU_
| L to U bias 0 - U bias, 1 - some U bias, 2 some L bias, 3 L bias.
int | persistenceFlag_
| Array persistence flag If 0 then as now (delete/new) 1 then only do arrays if bigger needed 2 as 1 but give a bit extra if bigger needed.
## Friends
void | CoinFactorizationUnitTest (const std::string &mpsDir)

## Detailed Description

This deals with Factorization and Updates.

This class started with a parallel simplex code I was writing in the mid 90's. The need for parallelism led to many complications and I have simplified as much as I could to get back to this.

I was aiming at problems where I might get speed-up so I was looking at dense problems or ones with structure. This led to permuting input and output vectors and to increasing the number of rows each rank-one update. This is still in as a minor overhead.

I have also put in handling for hyper-sparsity. I have taken out all outer loop unrolling, dense matrix handling and most of the book-keeping for slacks. Also I always use FTRAN approach to updating even if factorization fairly dense. All these could improve performance.

I blame some of the coding peculiarities on the history of the code but mostly it is just because I can't do elegant code (or useful comments).

I am assuming that 32 bits is enough for number of rows or columns, but CoinBigIndex may be redefined to get 64 bits.

Definition at line 47 of file CoinFactorization.hpp.

## Constructor & Destructor Documentation

CoinFactorization::CoinFactorization | ( |  | ) |

Default constructor.

CoinFactorization::CoinFactorization | ( | const CoinFactorization & | other | ) |

Copy constructor.

CoinFactorization::~CoinFactorization | ( |  | ) |

Destructor.

## Member Function Documentation

void CoinFactorization::almostDestructor | ( |  | ) |

Delete all stuff (leaves as after CoinFactorization()).

void CoinFactorization::show_self | ( |  | ) | const

Debug show object (shows one representation).

int CoinFactorization::saveFactorization | ( | const char * | file | ) | const

Debug - save on file - 0 if no error.

int CoinFactorization::restoreFactorization | ( | const char * | file,
|  | bool | factor = `false` |
| ) |  |  |

Debug - restore from file - 0 if no error on file.

If factor true then factorizes as if called from ClpFactorization

void CoinFactorization::sort | ( |  | ) | const

Debug - sort so can compare.

CoinFactorization& CoinFactorization::operator= | ( | const CoinFactorization & | other | ) |

= copy

int CoinFactorization::factorize | ( | const CoinPackedMatrix & | matrix,
|  | int | rowIsBasic[],
|  | int | columnIsBasic[],
|  | double | areaFactor = `0.0` |
| ) |  |  |

When part of LP - given by basic variables.

Actually does factorization. Arrays passed in have non negative value to say basic. If status is okay, basic variables have pivot row - this is only needed If status is singular, then basic variables have pivot row and ones thrown out have -1 returns 0 -okay, -1 singular, -2 too many in basis, -99 memory

int CoinFactorization::factorize | ( | int | numberRows,
|  | int | numberColumns,
|  | CoinBigIndex | numberElements,
|  | CoinBigIndex | maximumL,
|  | CoinBigIndex | maximumU,
|  | const int | indicesRow[],
|  | const int | indicesColumn[],
|  | const double | elements[],
|  | int | permutation[],
|  | double | areaFactor = `0.0` |
| ) |  |  |

When given as triplets.

Actually does factorization. maximumL is guessed maximum size of L part of final factorization, maximumU of U part. These are multiplied by areaFactor which can be computed by user or internally. Arrays are copied in. I could add flag to delete arrays to save a bit of memory. If status okay, permutation has pivot rows - this is only needed If status is singular, then basic variables have pivot row and ones thrown out have -1 returns 0 -okay, -1 singular, -99 memory

int CoinFactorization::factorizePart1 | ( | int | numberRows,
|  | int | numberColumns,
|  | CoinBigIndex | estimateNumberElements,
|  | int * | indicesRow[],
|  | int * | indicesColumn[],
|  | CoinFactorizationDouble * | elements[],
|  | double | areaFactor = `0.0` |
| ) |  |  |

Two part version for maximum flexibility This part creates arrays for user to fill.

estimateNumberElements is safe estimate of number returns 0 -okay, -99 memory

int CoinFactorization::factorizePart2 | ( | int | permutation[],
|  | int | exactNumberElements |
| ) |  |  |

This is part two of factorization Arrays belong to factorization and were returned by part 1 If status okay, permutation has pivot rows - this is only needed If status is singular, then basic variables have pivot row and ones thrown out have -1 returns 0 -okay, -1 singular, -99 memory.

double CoinFactorization::conditionNumber | ( |  | ) | const

Condition number - product of pivots after factorization.

int CoinFactorization::status | ( |  | ) | const`[inline]`

Returns status.

Definition at line 134 of file CoinFactorization.hpp.

References status_.

Referenced by ClpFactorization::status().

void CoinFactorization::setStatus | ( | int | value | ) | `[inline]`

Sets status.

Definition at line 138 of file CoinFactorization.hpp.

References status_.

Referenced by ClpFactorization::setStatus().

int CoinFactorization::pivots | ( |  | ) | const`[inline]`

Returns number of pivots since factorization.

Definition at line 141 of file CoinFactorization.hpp.

References numberPivots_.

Referenced by ClpFactorization::pivots().

void CoinFactorization::setPivots | ( | int | value | ) | `[inline]`

Sets number of pivots since factorization.

Definition at line 145 of file CoinFactorization.hpp.

References numberPivots_.

int* CoinFactorization::permute | ( |  | ) | const`[inline]`

Returns address of permute region.

Definition at line 148 of file CoinFactorization.hpp.

References CoinIntArrayWithLength::array(), and permute_.

Referenced by ClpFactorization::permute().

int* CoinFactorization::pivotColumn | ( |  | ) | const`[inline]`

Returns address of pivotColumn region (also used for permuting).

Definition at line 152 of file CoinFactorization.hpp.

References CoinIntArrayWithLength::array(), and pivotColumn_.

Referenced by ClpFactorization::pivotColumn().

CoinFactorizationDouble* CoinFactorization::pivotRegion | ( |  | ) | const`[inline]`

Returns address of pivot region.

Definition at line 156 of file CoinFactorization.hpp.

References CoinFactorizationDoubleArrayWithLength::array(), and pivotRegion_.

int* CoinFactorization::permuteBack | ( |  | ) | const`[inline]`

Returns address of permuteBack region.

Definition at line 160 of file CoinFactorization.hpp.

References CoinIntArrayWithLength::array(), and permuteBack_.

int* CoinFactorization::pivotColumnBack | ( |  | ) | const`[inline]`

Returns address of pivotColumnBack region (also used for permuting) Now uses firstCount to save memory allocation.

Definition at line 165 of file CoinFactorization.hpp.

References CoinIntArrayWithLength::array(), and pivotColumnBack_.

CoinBigIndex* CoinFactorization::startRowL | ( |  | ) | const`[inline]`

Start of each row in L.

Definition at line 170 of file CoinFactorization.hpp.

References CoinBigIndexArrayWithLength::array(), and startRowL_.

CoinBigIndex* CoinFactorization::startColumnL | ( |  | ) | const`[inline]`

Start of each column in L.

Definition at line 174 of file CoinFactorization.hpp.

References CoinBigIndexArrayWithLength::array(), and startColumnL_.

int* CoinFactorization::indexColumnL | ( |  | ) | const`[inline]`

Index of column in row for L.

Definition at line 178 of file CoinFactorization.hpp.

References CoinIntArrayWithLength::array(), and indexColumnL_.

int* CoinFactorization::indexRowL | ( |  | ) | const`[inline]`

Row indices of L.

Definition at line 182 of file CoinFactorization.hpp.

References CoinIntArrayWithLength::array(), and indexRowL_.

CoinFactorizationDouble* CoinFactorization::elementByRowL | ( |  | ) | const`[inline]`

Elements in L (row copy).

Definition at line 186 of file CoinFactorization.hpp.

References CoinFactorizationDoubleArrayWithLength::array(), and elementByRowL_.

int CoinFactorization::numberRowsExtra | ( |  | ) | const`[inline]`

Number of Rows after iterating.

Definition at line 190 of file CoinFactorization.hpp.

References numberRowsExtra_.

void CoinFactorization::setNumberRows | ( | int | value | ) | `[inline]`

Set number of Rows after factorization.

Definition at line 194 of file CoinFactorization.hpp.

References numberRows_.

int CoinFactorization::numberRows | ( |  | ) | const`[inline]`

Number of Rows after factorization.

Definition at line 197 of file CoinFactorization.hpp.

References numberRows_.

CoinBigIndex CoinFactorization::numberL | ( |  | ) | const`[inline]`

Number in L.

Definition at line 201 of file CoinFactorization.hpp.

References numberL_.

CoinBigIndex CoinFactorization::baseL | ( |  | ) | const`[inline]`

Base of L.

Definition at line 205 of file CoinFactorization.hpp.

References baseL_.

int CoinFactorization::maximumRowsExtra | ( |  | ) | const`[inline]`

Maximum of Rows after iterating.

Definition at line 208 of file CoinFactorization.hpp.

References maximumRowsExtra_.

int CoinFactorization::numberColumns | ( |  | ) | const`[inline]`

Total number of columns in factorization.

Definition at line 212 of file CoinFactorization.hpp.

References numberColumns_.

int CoinFactorization::numberElements | ( |  | ) | const`[inline]`

Total number of elements in factorization.

Definition at line 216 of file CoinFactorization.hpp.

References totalElements_.

Referenced by ClpFactorization::numberElements().

int CoinFactorization::numberForrestTomlin | ( |  | ) | const`[inline]`

Length of FT vector.

Definition at line 220 of file CoinFactorization.hpp.

References CoinIntArrayWithLength::array(), numberColumnsExtra_, and numberInColumn_.

int CoinFactorization::numberGoodColumns | ( |  | ) | const`[inline]`

Number of good columns in factorization.

Definition at line 224 of file CoinFactorization.hpp.

References numberGoodU_.

double CoinFactorization::areaFactor | ( |  | ) | const`[inline]`

Whether larger areas needed.

Definition at line 228 of file CoinFactorization.hpp.

References areaFactor_.

Referenced by ClpFactorization::areaFactor().

void CoinFactorization::areaFactor | ( | double | value | ) | `[inline]`

Returns status.

Definition at line 231 of file CoinFactorization.hpp.

References areaFactor_.

double CoinFactorization::adjustedAreaFactor | ( |  | ) | const

Returns areaFactor but adjusted for dense.

void CoinFactorization::relaxAccuracyCheck | ( | double | value | ) | `[inline]`

Allows change of pivot accuracy check 1.0 == none >1.0 relaxed.

Definition at line 237 of file CoinFactorization.hpp.

References relaxCheck_.

double CoinFactorization::getAccuracyCheck | ( |  | ) | const`[inline]`

Returns status.

Definition at line 239 of file CoinFactorization.hpp.

References relaxCheck_.

int CoinFactorization::messageLevel | ( |  | ) | const`[inline]`

Level of detail of messages.

Definition at line 242 of file CoinFactorization.hpp.

References messageLevel_.

void CoinFactorization::messageLevel | ( | int | value | ) |

Returns status.

int CoinFactorization::maximumPivots | ( |  | ) | const`[inline]`

Maximum number of pivots between factorizations.

Definition at line 247 of file CoinFactorization.hpp.

References maximumPivots_.

Referenced by ClpFactorization::maximumPivots().

void CoinFactorization::maximumPivots | ( | int | value | ) |

Returns status.

int CoinFactorization::denseThreshold | ( |  | ) | const`[inline]`

Gets dense threshold.

Definition at line 253 of file CoinFactorization.hpp.

References denseThreshold_.

void CoinFactorization::setDenseThreshold | ( | int | value | ) | `[inline]`

Sets dense threshold.

Definition at line 256 of file CoinFactorization.hpp.

References denseThreshold_.

double CoinFactorization::pivotTolerance | ( |  | ) | const`[inline]`

Pivot tolerance.

Definition at line 259 of file CoinFactorization.hpp.

References pivotTolerance_.

void CoinFactorization::pivotTolerance | ( | double | value | ) |

Returns status.

double CoinFactorization::zeroTolerance | ( |  | ) | const`[inline]`

Zero tolerance.

Definition at line 264 of file CoinFactorization.hpp.

References zeroTolerance_.

Referenced by ClpFactorization::zeroTolerance().

void CoinFactorization::zeroTolerance | ( | double | value | ) |

Returns status.

double CoinFactorization::slackValue | ( |  | ) | const`[inline]`

Whether slack value is +1 or -1.

Definition at line 270 of file CoinFactorization.hpp.

void CoinFactorization::slackValue | ( | double | value | ) |

Returns status.

double CoinFactorization::maximumCoefficient | ( |  | ) | const

Returns maximum absolute value in factorization.

bool CoinFactorization::forrestTomlin | ( |  | ) | const`[inline]`

true if Forrest Tomlin update, false if PFI

Definition at line 278 of file CoinFactorization.hpp.

void CoinFactorization::setForrestTomlin | ( | bool | value | ) | `[inline]`

Returns status.

Definition at line 280 of file CoinFactorization.hpp.

bool CoinFactorization::spaceForForrestTomlin | ( |  | ) | const`[inline]`

True if FT update and space.

Definition at line 283 of file CoinFactorization.hpp.

int CoinFactorization::numberDense | ( |  | ) | const`[inline]`

Returns number of dense rows.

Definition at line 295 of file CoinFactorization.hpp.

Referenced by ClpFactorization::numberDense().

CoinBigIndex CoinFactorization::numberElementsU | ( |  | ) | const`[inline]`

Returns number in U area.

Definition at line 299 of file CoinFactorization.hpp.

void CoinFactorization::setNumberElementsU | ( | CoinBigIndex | value | ) | `[inline]`

Setss number in U area.

Definition at line 303 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::lengthAreaU | ( |  | ) | const`[inline]`

Returns length of U area.

Definition at line 306 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::numberElementsL | ( |  | ) | const`[inline]`

Returns number in L area.

Definition at line 310 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::lengthAreaL | ( |  | ) | const`[inline]`

Returns length of L area.

Definition at line 314 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::numberElementsR | ( |  | ) | const`[inline]`

Returns number in R area.

Definition at line 318 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::numberCompressions | ( |  | ) | const`[inline]`

Number of compressions done.

Definition at line 322 of file CoinFactorization.hpp.

int* CoinFactorization::numberInRow | ( |  | ) | const`[inline]`

Number of entries in each row.

Definition at line 325 of file CoinFactorization.hpp.

int* CoinFactorization::numberInColumn | ( |  | ) | const`[inline]`

Number of entries in each column.

Definition at line 328 of file CoinFactorization.hpp.

CoinFactorizationDouble* CoinFactorization::elementU | ( |  | ) | const`[inline]`

Elements of U.

Definition at line 331 of file CoinFactorization.hpp.

int* CoinFactorization::indexRowU | ( |  | ) | const`[inline]`

Row indices of U.

Definition at line 334 of file CoinFactorization.hpp.

CoinBigIndex* CoinFactorization::startColumnU | ( |  | ) | const`[inline]`

Start of each column in U.

Definition at line 337 of file CoinFactorization.hpp.

int CoinFactorization::maximumColumnsExtra | ( |  | ) | `[inline]`

Maximum number of Columns after iterating.

Definition at line 340 of file CoinFactorization.hpp.

int CoinFactorization::biasLU | ( |  | ) | const`[inline]`

L to U bias 0 - U bias, 1 - some U bias, 2 some L bias, 3 L bias.

Definition at line 345 of file CoinFactorization.hpp.

void CoinFactorization::setBiasLU | ( | int | value | ) | `[inline]`

Returns number of dense rows.

Definition at line 347 of file CoinFactorization.hpp.

int CoinFactorization::persistenceFlag | ( |  | ) | const`[inline]`

Array persistence flag If 0 then as now (delete/new) 1 then only do arrays if bigger needed 2 as 1 but give a bit extra if bigger needed.

Definition at line 354 of file CoinFactorization.hpp.

void CoinFactorization::setPersistenceFlag | ( | int | value | ) |

Returns number of dense rows.

int CoinFactorization::replaceColumn | ( | CoinIndexedVector * | regionSparse,
|  | int | pivotRow,
|  | double | pivotCheck,
|  | bool | checkBeforeModifying = `false`,
|  | double | acceptablePivot = `1.0e-8` |
| ) |  |  |

Replaces one Column to basis, returns 0=OK, 1=Probably OK, 2=singular, 3=no room If checkBeforeModifying is true will do all accuracy checks before modifying factorization.

Whether to set this depends on speed considerations. You could just do this on first iteration after factorization and thereafter re-factorize partial update already in U

void CoinFactorization::replaceColumnU | ( | CoinIndexedVector * | regionSparse,
|  | CoinBigIndex * | deleted,
|  | int | internalPivotRow |
| ) |  |  |

Combines BtranU and delete elements If deleted is NULL then delete elements otherwise store where elements are.

int CoinFactorization::updateColumnFT | ( | CoinIndexedVector * | regionSparse,
|  | CoinIndexedVector * | regionSparse2 |
| ) |  |  |

Updates one column (FTRAN) from regionSparse2 Tries to do FT update number returned is negative if no room regionSparse starts as zero and is zero at end.

Note - if regionSparse2 packed on input - will be packed on output

int CoinFactorization::updateColumn | ( | CoinIndexedVector * | regionSparse,
|  | CoinIndexedVector * | regionSparse2,
|  | bool | noPermute = `false` |
| ) |  |  | const

This version has same effect as above with FTUpdate==false so number returned is always >=0.

int CoinFactorization::updateTwoColumnsFT | ( | CoinIndexedVector * | regionSparse1,
|  | CoinIndexedVector * | regionSparse2,
|  | CoinIndexedVector * | regionSparse3,
|  | bool | noPermuteRegion3 = `false` |
| ) |  |  |

Updates one column (FTRAN) from region2 Tries to do FT update number returned is negative if no room.

Also updates region3 region1 starts as zero and is zero at end

int CoinFactorization::updateColumnTranspose | ( | CoinIndexedVector * | regionSparse,
|  | CoinIndexedVector * | regionSparse2 |
| ) |  |  | const

Updates one column (BTRAN) from regionSparse2 regionSparse starts as zero and is zero at end Note - if regionSparse2 packed on input - will be packed on output.

void CoinFactorization::goSparse | ( |  | ) |

makes a row copy of L for speed and to allow very sparse problems

int CoinFactorization::sparseThreshold | ( |  | ) | const`[inline]`

get sparse threshold

Definition at line 417 of file CoinFactorization.hpp.

Referenced by ClpFactorization::sparseThreshold().

void CoinFactorization::sparseThreshold | ( | int | value | ) |

set sparse threshold

void CoinFactorization::clearArrays | ( |  | ) | `[inline]`

Get rid of all memory.

Definition at line 428 of file CoinFactorization.hpp.

int CoinFactorization::add | ( | CoinBigIndex | numberElements,
|  | int | indicesRow[],
|  | int | indicesColumn[],
|  | double | elements[] |
| ) |  |  |

Adds given elements to Basis and updates factorization, can increase size of basis.

Returns rank

int CoinFactorization::addColumn | ( | CoinBigIndex | numberElements,
|  | int | indicesRow[],
|  | double | elements[] |
| ) |  |  |

Adds one Column to basis, can increase size of basis.

Returns rank

int CoinFactorization::addRow | ( | CoinBigIndex | numberElements,
|  | int | indicesColumn[],
|  | double | elements[] |
| ) |  |  |

Adds one Row to basis, can increase size of basis.

Returns rank

int CoinFactorization::deleteColumn | ( | int | Row | ) |

Deletes one Column from basis, returns rank.

int CoinFactorization::deleteRow | ( | int | Row | ) |

Deletes one Row from basis, returns rank.

int CoinFactorization::replaceRow | ( | int | whichRow,
|  | int | numberElements,
|  | const int | indicesColumn[],
|  | const double | elements[] |
| ) |  |  |

Replaces one Row in basis, At present assumes just a singleton on row is in basis returns 0=OK, 1=Probably OK, 2=singular, 3 no space.

void CoinFactorization::emptyRows | ( | int | numberToEmpty,
|  | const int | which[] |
| ) |  |  |

Takes out all entries for given rows.

void CoinFactorization::checkSparse | ( |  | ) |

See if worth going sparse.

bool CoinFactorization::collectStatistics | ( |  | ) | const`[inline]`

For statistics.

Definition at line 468 of file CoinFactorization.hpp.

void CoinFactorization::setCollectStatistics | ( | bool | onOff | ) | const`[inline]`

For statistics.

Definition at line 471 of file CoinFactorization.hpp.

void CoinFactorization::gutsOfDestructor | ( | int | type = `1` | ) |

The real work of constructors etc 0 just scalars, 1 bit normal.

void CoinFactorization::gutsOfInitialize | ( | int | type | ) |

1 bit - tolerances etc, 2 more, 4 dummy arrays

void CoinFactorization::gutsOfCopy | ( | const CoinFactorization & | other | ) |

See if worth going sparse.

void CoinFactorization::resetStatistics | ( |  | ) |

Reset all sparsity etc statistics.

void CoinFactorization::getAreas | ( | int | numberRows,
|  | int | numberColumns,
|  | CoinBigIndex | maximumL,
|  | CoinBigIndex | maximumU |
| ) |  |  |

Gets space for a factorization, called by constructors.

void CoinFactorization::preProcess | ( | int | state,
|  | int | possibleDuplicates = `-1` |
| ) |  |  |

PreProcesses raw triplet data.

state is 0 - triplets, 1 - some counts etc , 2 - ..

int CoinFactorization::factor | ( |  | ) |

Does most of factorization.

int CoinFactorization::factorSparse | ( |  | ) | `[protected]`

Does sparse phase of factorization return code is <0 error, 0= finished.

int CoinFactorization::factorSparseSmall | ( |  | ) | `[protected]`

Does sparse phase of factorization (for smaller problems) return code is <0 error, 0= finished.

int CoinFactorization::factorSparseLarge | ( |  | ) | `[protected]`

Does sparse phase of factorization (for larger problems) return code is <0 error, 0= finished.

int CoinFactorization::factorDense | ( |  | ) | `[protected]`

Does dense phase of factorization return code is <0 error, 0= finished.

bool CoinFactorization::pivotOneOtherRow | ( | int | pivotRow,
|  | int | pivotColumn |
| ) |  |  | `[protected]`

Pivots when just one other row so faster?

bool CoinFactorization::pivotRowSingleton | ( | int | pivotRow,
|  | int | pivotColumn |
| ) |  |  | `[protected]`

Does one pivot on Row Singleton in factorization.

bool CoinFactorization::pivotColumnSingleton | ( | int | pivotRow,
|  | int | pivotColumn |
| ) |  |  | `[protected]`

Does one pivot on Column Singleton in factorization.

bool CoinFactorization::getColumnSpace | ( | int | iColumn,
|  | int | extraNeeded |
| ) |  |  | `[protected]`

Gets space for one Column with given length, may have to do compression (returns True if successful), also moves existing vector, extraNeeded is over and above present.

bool CoinFactorization::reorderU | ( |  | ) | `[protected]`

Reorders U so contiguous and in order (if there is space) Returns true if it could.

bool CoinFactorization::getColumnSpaceIterateR | ( | int | iColumn,
|  | double | value,
|  | int | iRow |
| ) |  |  | `[protected]`

getColumnSpaceIterateR.

Gets space for one extra R element in Column may have to do compression (returns true) also moves existing vector

CoinBigIndex CoinFactorization::getColumnSpaceIterate | ( | int | iColumn,
|  | double | value,
|  | int | iRow |
| ) |  |  | `[protected]`

getColumnSpaceIterate.

Gets space for one extra U element in Column may have to do compression (returns true) also moves existing vector. Returns -1 if no memory or where element was put Used by replaceRow (turns off R version)

bool CoinFactorization::getRowSpace | ( | int | iRow,
|  | int | extraNeeded |
| ) |  |  | `[protected]`

Gets space for one Row with given length, may have to do compression (returns True if successful), also moves existing vector.

bool CoinFactorization::getRowSpaceIterate | ( | int | iRow,
|  | int | extraNeeded |
| ) |  |  | `[protected]`

Gets space for one Row with given length while iterating, may have to do compression (returns True if successful), also moves existing vector.

void CoinFactorization::checkConsistency | ( |  | ) | `[protected]`

Checks that row and column copies look OK.

void CoinFactorization::addLink | ( | int | index,
|  | int | count |
| ) |  |  | `[inline, protected]`

Adds a link in chain of equal counts.

Definition at line 557 of file CoinFactorization.hpp.

void CoinFactorization::deleteLink | ( | int | index | ) | `[inline, protected]`

Deletes a link in chain of equal counts.

Definition at line 573 of file CoinFactorization.hpp.

void CoinFactorization::separateLinks | ( | int | count,
|  | bool | rowsFirst |
| ) |  |  | `[protected]`

Separate out links with same row/column count.

void CoinFactorization::cleanup | ( |  | ) | `[protected]`

Cleans up at end of factorization.

void CoinFactorization::updateColumnL | ( | CoinIndexedVector * | region,
|  | int * | indexIn |
| ) |  |  | const`[protected]`

Updates part of column (FTRANL).

void CoinFactorization::updateColumnLDensish | ( | CoinIndexedVector * | region,
|  | int * | indexIn |
| ) |  |  | const`[protected]`

Updates part of column (FTRANL) when densish.

void CoinFactorization::updateColumnLSparse | ( | CoinIndexedVector * | region,
|  | int * | indexIn |
| ) |  |  | const`[protected]`

Updates part of column (FTRANL) when sparse.

void CoinFactorization::updateColumnLSparsish | ( | CoinIndexedVector * | region,
|  | int * | indexIn |
| ) |  |  | const`[protected]`

Updates part of column (FTRANL) when sparsish.

void CoinFactorization::updateColumnR | ( | CoinIndexedVector * | region | ) | const`[protected]`

Updates part of column (FTRANR) without FT update.

void CoinFactorization::updateColumnRFT | ( | CoinIndexedVector * | region,
|  | int * | indexIn |
| ) |  |  | `[protected]`

Updates part of column (FTRANR) with FT update.

Also stores update after L and R

void CoinFactorization::updateColumnU | ( | CoinIndexedVector * | region,
|  | int * | indexIn |
| ) |  |  | const`[protected]`

Updates part of column (FTRANU).

void CoinFactorization::updateColumnUSparse | ( | CoinIndexedVector * | regionSparse,
|  | int * | indexIn |
| ) |  |  | const`[protected]`

Updates part of column (FTRANU) when sparse.

void CoinFactorization::updateColumnUSparsish | ( | CoinIndexedVector * | regionSparse,
|  | int * | indexIn |
| ) |  |  | const`[protected]`

Updates part of column (FTRANU) when sparsish.

int CoinFactorization::updateColumnUDensish | ( | double *COIN_RESTRICT | region,
|  | int *COIN_RESTRICT | regionIndex |
| ) |  |  | const`[protected]`

Updates part of column (FTRANU).

void CoinFactorization::updateTwoColumnsUDensish | ( | int & | numberNonZero1,
|  | double *COIN_RESTRICT | region1,
|  | int *COIN_RESTRICT | index1,
|  | int & | numberNonZero2,
|  | double *COIN_RESTRICT | region2,
|  | int *COIN_RESTRICT | index2 |
| ) |  |  | const`[protected]`

Updates part of 2 columns (FTRANU) real work.

void CoinFactorization::updateColumnPFI | ( | CoinIndexedVector * | regionSparse | ) | const`[protected]`

Updates part of column PFI (FTRAN) (after rest).

void CoinFactorization::permuteBack | ( | CoinIndexedVector * | regionSparse,
|  | CoinIndexedVector * | outVector |
| ) |  |  | const`[protected]`

Permutes back at end of updateColumn.

void CoinFactorization::updateColumnTransposePFI | ( | CoinIndexedVector * | region | ) | const`[protected]`

Updates part of column transpose PFI (BTRAN) (before rest).

void CoinFactorization::updateColumnTransposeU | ( | CoinIndexedVector * | region,
|  | int | smallestIndex |
| ) |  |  | const`[protected]`

Updates part of column transpose (BTRANU), assumes index is sorted i.e.

region is correct

void CoinFactorization::updateColumnTransposeUSparsish | ( | CoinIndexedVector * | region,
|  | int | smallestIndex |
| ) |  |  | const`[protected]`

Updates part of column transpose (BTRANU) when sparsish, assumes index is sorted i.e.

region is correct

void CoinFactorization::updateColumnTransposeUDensish | ( | CoinIndexedVector * | region,
|  | int | smallestIndex |
| ) |  |  | const`[protected]`

Updates part of column transpose (BTRANU) when densish, assumes index is sorted i.e.

region is correct

void CoinFactorization::updateColumnTransposeUSparse | ( | CoinIndexedVector * | region | ) | const`[protected]`

Updates part of column transpose (BTRANU) when sparse, assumes index is sorted i.e.

region is correct

void CoinFactorization::updateColumnTransposeUByColumn | ( | CoinIndexedVector * | region,
|  | int | smallestIndex |
| ) |  |  | const`[protected]`

Updates part of column transpose (BTRANU) by column assumes index is sorted i.e.

region is correct

void CoinFactorization::updateColumnTransposeR | ( | CoinIndexedVector * | region | ) | const`[protected]`

Updates part of column transpose (BTRANR).

void CoinFactorization::updateColumnTransposeRDensish | ( | CoinIndexedVector * | region | ) | const`[protected]`

Updates part of column transpose (BTRANR) when dense.

void CoinFactorization::updateColumnTransposeRSparse | ( | CoinIndexedVector * | region | ) | const`[protected]`

Updates part of column transpose (BTRANR) when sparse.

void CoinFactorization::updateColumnTransposeL | ( | CoinIndexedVector * | region | ) | const`[protected]`

Updates part of column transpose (BTRANL).

void CoinFactorization::updateColumnTransposeLDensish | ( | CoinIndexedVector * | region | ) | const`[protected]`

Updates part of column transpose (BTRANL) when densish by column.

void CoinFactorization::updateColumnTransposeLByRow | ( | CoinIndexedVector * | region | ) | const`[protected]`

Updates part of column transpose (BTRANL) when densish by row.

void CoinFactorization::updateColumnTransposeLSparsish | ( | CoinIndexedVector * | region | ) | const`[protected]`

Updates part of column transpose (BTRANL) when sparsish by row.

void CoinFactorization::updateColumnTransposeLSparse | ( | CoinIndexedVector * | region | ) | const`[protected]`

Updates part of column transpose (BTRANL) when sparse (by Row).

int CoinFactorization::replaceColumnPFI | ( | CoinIndexedVector * | regionSparse,
|  | int | pivotRow,
|  | double | alpha |
| ) |  |  |

Replaces one Column to basis for PFI returns 0=OK, 1=Probably OK, 2=singular, 3=no room.

In this case region is not empty - it is incoming variable (updated)

int CoinFactorization::checkPivot | ( | double | saveFromU,
|  | double | oldPivot |
| ) |  |  | const`[protected]`

Returns accuracy status of replaceColumn returns 0=OK, 1=Probably OK, 2=singular.

template<class T>

bool CoinFactorization::pivot | ( | int | pivotRow,
|  | int | pivotColumn,
|  | CoinBigIndex | pivotRowPosition,
|  | CoinBigIndex | pivotColumnPosition,
|  | CoinFactorizationDouble | work[],
|  | unsigned int | workArea2[],
|  | int | increment2,
|  | T | markRow[],
|  | int | largeInteger |
| ) |  |  | `[inline, protected]`

Gets space for a factorization, called by constructors.

Definition at line 700 of file CoinFactorization.hpp.

References COINFACTORIZATION_BITS_PER_INT, COINFACTORIZATION_MASK_PER_INT, and COINFACTORIZATION_SHIFT_PER_INT.

## Friends And Related Function Documentation

void CoinFactorizationUnitTest | ( | const std::string & | mpsDir | ) | `[friend]`

## Member Data Documentation

double CoinFactorization::pivotTolerance_`[protected]`

Pivot tolerance.

Definition at line 1182 of file CoinFactorization.hpp.

Referenced by pivotTolerance().

double CoinFactorization::zeroTolerance_`[protected]`

Zero tolerance.

Definition at line 1184 of file CoinFactorization.hpp.

Referenced by zeroTolerance().

double CoinFactorization::slackValue_`[protected]`

Whether slack value is +1 or -1.

Definition at line 1187 of file CoinFactorization.hpp.

double CoinFactorization::areaFactor_`[protected]`

How much to multiply areas by.

Definition at line 1194 of file CoinFactorization.hpp.

Referenced by areaFactor().

double CoinFactorization::relaxCheck_`[protected]`

Relax check on accuracy in replaceColumn.

Definition at line 1196 of file CoinFactorization.hpp.

Referenced by getAccuracyCheck(), and relaxAccuracyCheck().

int CoinFactorization::numberRows_`[protected]`

Number of Rows in factorization.

Definition at line 1198 of file CoinFactorization.hpp.

Referenced by numberRows(), and setNumberRows().

int CoinFactorization::numberRowsExtra_`[protected]`

Number of Rows after iterating.

Definition at line 1200 of file CoinFactorization.hpp.

Referenced by numberRowsExtra().

int CoinFactorization::maximumRowsExtra_`[protected]`

Maximum number of Rows after iterating.

Definition at line 1202 of file CoinFactorization.hpp.

Referenced by maximumRowsExtra().

int CoinFactorization::numberColumns_`[protected]`

Number of Columns in factorization.

Definition at line 1204 of file CoinFactorization.hpp.

Referenced by numberColumns().

int CoinFactorization::numberColumnsExtra_`[protected]`

Number of Columns after iterating.

Definition at line 1206 of file CoinFactorization.hpp.

Referenced by numberForrestTomlin().

int CoinFactorization::maximumColumnsExtra_`[protected]`

Maximum number of Columns after iterating.

Definition at line 1208 of file CoinFactorization.hpp.

int CoinFactorization::numberGoodU_`[protected]`

Number factorized in U (not row singletons).

Definition at line 1210 of file CoinFactorization.hpp.

Referenced by numberGoodColumns().

int CoinFactorization::numberGoodL_`[protected]`

Number factorized in L.

Definition at line 1212 of file CoinFactorization.hpp.

int CoinFactorization::maximumPivots_`[protected]`

Maximum number of pivots before factorization.

Definition at line 1214 of file CoinFactorization.hpp.

Referenced by maximumPivots().

int CoinFactorization::numberPivots_`[protected]`

Number pivots since last factorization.

Definition at line 1216 of file CoinFactorization.hpp.

Referenced by pivots(), and setPivots().

CoinBigIndex CoinFactorization::totalElements_`[protected]`

Number of elements in U (to go) or while iterating total overall.

Definition at line 1219 of file CoinFactorization.hpp.

Referenced by numberElements().

CoinBigIndex CoinFactorization::factorElements_`[protected]`

Number of elements after factorization.

Definition at line 1221 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::pivotColumn_`[protected]`

Pivot order for each Column.

Definition at line 1223 of file CoinFactorization.hpp.

Referenced by pivotColumn().

CoinIntArrayWithLength CoinFactorization::permute_`[protected]`

Permutation vector for pivot row order.

Definition at line 1225 of file CoinFactorization.hpp.

Referenced by permute().

CoinIntArrayWithLength CoinFactorization::permuteBack_`[protected]`

DePermutation vector for pivot row order.

Definition at line 1227 of file CoinFactorization.hpp.

Referenced by permuteBack().

CoinIntArrayWithLength CoinFactorization::pivotColumnBack_`[protected]`

Inverse Pivot order for each Column.

Definition at line 1229 of file CoinFactorization.hpp.

Referenced by pivotColumnBack().

int CoinFactorization::status_`[protected]`

Status of factorization.

Definition at line 1231 of file CoinFactorization.hpp.

Referenced by setStatus(), and status().

int CoinFactorization::numberTrials_`[protected]`

Number of trials before rejection.

Definition at line 1240 of file CoinFactorization.hpp.

CoinBigIndexArrayWithLength CoinFactorization::startRowU_`[protected]`

Start of each Row as pointer.

Definition at line 1242 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::numberInRow_`[protected]`

Number in each Row.

Definition at line 1245 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::numberInColumn_`[protected]`

Number in each Column.

Definition at line 1248 of file CoinFactorization.hpp.

Referenced by numberForrestTomlin().

CoinIntArrayWithLength CoinFactorization::numberInColumnPlus_`[protected]`

Number in each Column including pivoted.

Definition at line 1251 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::firstCount_`[protected]`

First Row/Column with count of k, can tell which by offset - Rows then Columns.

Definition at line 1255 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::nextCount_`[protected]`

Next Row/Column with count.

Definition at line 1258 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::lastCount_`[protected]`

Previous Row/Column with count.

Definition at line 1261 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::nextColumn_`[protected]`

Next Column in memory order.

Definition at line 1264 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::lastColumn_`[protected]`

Previous Column in memory order.

Definition at line 1267 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::nextRow_`[protected]`

Next Row in memory order.

Definition at line 1270 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::lastRow_`[protected]`

Previous Row in memory order.

Definition at line 1273 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::saveColumn_`[protected]`

Columns left to do in a single pivot.

Definition at line 1276 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::markRow_`[protected]`

Marks rows to be updated.

Definition at line 1279 of file CoinFactorization.hpp.

int CoinFactorization::messageLevel_`[protected]`

Detail in messages.

Definition at line 1282 of file CoinFactorization.hpp.

Referenced by messageLevel().

int CoinFactorization::biggerDimension_`[protected]`

Larger of row and column size.

Definition at line 1285 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::indexColumnU_`[protected]`

Base address for U (may change).

Definition at line 1288 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::pivotRowL_`[protected]`

Pivots for L.

Definition at line 1291 of file CoinFactorization.hpp.

CoinFactorizationDoubleArrayWithLength CoinFactorization::pivotRegion_`[protected]`

Inverses of pivot values.

Definition at line 1294 of file CoinFactorization.hpp.

Referenced by pivotRegion().

int CoinFactorization::numberSlacks_`[protected]`

Number of slacks at beginning of U.

Definition at line 1297 of file CoinFactorization.hpp.

int CoinFactorization::numberU_`[protected]`

Number in U.

Definition at line 1300 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::maximumU_`[protected]`

Maximum space used in U.

Definition at line 1303 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::lengthU_`[protected]`

Length of U.

Definition at line 1309 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::lengthAreaU_`[protected]`

Length of area reserved for U.

Definition at line 1312 of file CoinFactorization.hpp.

CoinFactorizationDoubleArrayWithLength CoinFactorization::elementU_`[protected]`

Elements of U.

Definition at line 1315 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::indexRowU_`[protected]`

Row indices of U.

Definition at line 1318 of file CoinFactorization.hpp.

CoinBigIndexArrayWithLength CoinFactorization::startColumnU_`[protected]`

Start of each column in U.

Definition at line 1321 of file CoinFactorization.hpp.

CoinBigIndexArrayWithLength CoinFactorization::convertRowToColumnU_`[protected]`

Converts rows to columns in U.

Definition at line 1324 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::numberL_`[protected]`

Number in L.

Definition at line 1327 of file CoinFactorization.hpp.

Referenced by numberL().

CoinBigIndex CoinFactorization::baseL_`[protected]`

Base of L.

Definition at line 1330 of file CoinFactorization.hpp.

Referenced by baseL().

CoinBigIndex CoinFactorization::lengthL_`[protected]`

Length of L.

Definition at line 1333 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::lengthAreaL_`[protected]`

Length of area reserved for L.

Definition at line 1336 of file CoinFactorization.hpp.

CoinFactorizationDoubleArrayWithLength CoinFactorization::elementL_`[protected]`

Elements of L.

Definition at line 1339 of file CoinFactorization.hpp.

CoinIntArrayWithLength CoinFactorization::indexRowL_`[protected]`

Row indices of L.

Definition at line 1342 of file CoinFactorization.hpp.

Referenced by indexRowL().

CoinBigIndexArrayWithLength CoinFactorization::startColumnL_`[protected]`

Start of each column in L.

Definition at line 1345 of file CoinFactorization.hpp.

Referenced by startColumnL().

bool CoinFactorization::doForrestTomlin_`[protected]`

true if Forrest Tomlin update, false if PFI

Definition at line 1348 of file CoinFactorization.hpp.

int CoinFactorization::numberR_`[protected]`

Number in R.

Definition at line 1351 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::lengthR_`[protected]`

Length of R stuff.

Definition at line 1354 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::lengthAreaR_`[protected]`

length of area reserved for R

Definition at line 1357 of file CoinFactorization.hpp.

CoinFactorizationDouble* CoinFactorization::elementR_`[protected]`

Elements of R.

Definition at line 1360 of file CoinFactorization.hpp.

int* CoinFactorization::indexRowR_`[protected]`

Row indices for R.

Definition at line 1363 of file CoinFactorization.hpp.

CoinBigIndexArrayWithLength CoinFactorization::startColumnR_`[protected]`

Start of columns for R.

Definition at line 1366 of file CoinFactorization.hpp.

double* CoinFactorization::denseArea_`[protected]`

Dense area.

Definition at line 1369 of file CoinFactorization.hpp.

int* CoinFactorization::densePermute_`[protected]`

Dense permutation.

Definition at line 1372 of file CoinFactorization.hpp.

int CoinFactorization::numberDense_`[protected]`

Number of dense rows.

Definition at line 1375 of file CoinFactorization.hpp.

int CoinFactorization::denseThreshold_`[protected]`

Dense threshold.

Definition at line 1378 of file CoinFactorization.hpp.

Referenced by denseThreshold(), and setDenseThreshold().

CoinFactorizationDoubleArrayWithLength CoinFactorization::workArea_`[protected]`

First work area.

Definition at line 1381 of file CoinFactorization.hpp.

CoinUnsignedIntArrayWithLength CoinFactorization::workArea2_`[protected]`

Second work area.

Definition at line 1384 of file CoinFactorization.hpp.

CoinBigIndex CoinFactorization::numberCompressions_`[protected]`

Number of compressions done.

Definition at line 1387 of file CoinFactorization.hpp.

double CoinFactorization::ftranCountInput_`[mutable, protected]`

Below are all to collect.

Definition at line 1390 of file CoinFactorization.hpp.

double CoinFactorization::ftranCountAfterL_`[mutable, protected]`

Pivot tolerance.

Definition at line 1391 of file CoinFactorization.hpp.

double CoinFactorization::ftranCountAfterR_`[mutable, protected]`

Pivot tolerance.

Definition at line 1392 of file CoinFactorization.hpp.

double CoinFactorization::ftranCountAfterU_`[mutable, protected]`

Pivot tolerance.

Definition at line 1393 of file CoinFactorization.hpp.

double CoinFactorization::btranCountInput_`[mutable, protected]`

Pivot tolerance.

Definition at line 1394 of file CoinFactorization.hpp.

double CoinFactorization::btranCountAfterU_`[mutable, protected]`

Pivot tolerance.

Definition at line 1395 of file CoinFactorization.hpp.

double CoinFactorization::btranCountAfterR_`[mutable, protected]`

Pivot tolerance.

Definition at line 1396 of file CoinFactorization.hpp.

double CoinFactorization::btranCountAfterL_`[mutable, protected]`

Pivot tolerance.

Definition at line 1397 of file CoinFactorization.hpp.

int CoinFactorization::numberFtranCounts_`[mutable, protected]`

We can roll over factorizations.

Definition at line 1400 of file CoinFactorization.hpp.

int CoinFactorization::numberBtranCounts_`[mutable, protected]`

Pivot tolerance.

Definition at line 1401 of file CoinFactorization.hpp.

double CoinFactorization::ftranAverageAfterL_`[protected]`

While these are average ratios collected over last period.

Definition at line 1404 of file CoinFactorization.hpp.

double CoinFactorization::ftranAverageAfterR_`[protected]`

Pivot tolerance.

Definition at line 1405 of file CoinFactorization.hpp.

double CoinFactorization::ftranAverageAfterU_`[protected]`

Pivot tolerance.

Definition at line 1406 of file CoinFactorization.hpp.

double CoinFactorization::btranAverageAfterU_`[protected]`

Pivot tolerance.

Definition at line 1407 of file CoinFactorization.hpp.

double CoinFactorization::btranAverageAfterR_`[protected]`

Pivot tolerance.

Definition at line 1408 of file CoinFactorization.hpp.

double CoinFactorization::btranAverageAfterL_`[protected]`

Pivot tolerance.

Definition at line 1409 of file CoinFactorization.hpp.

bool CoinFactorization::collectStatistics_`[mutable, protected]`

For statistics.

Definition at line 1412 of file CoinFactorization.hpp.

int CoinFactorization::sparseThreshold_`[protected]`

Below this use sparse technology - if 0 then no L row copy.

Definition at line 1415 of file CoinFactorization.hpp.

int CoinFactorization::sparseThreshold2_`[protected]`

And one for "sparsish".

Definition at line 1418 of file CoinFactorization.hpp.

CoinBigIndexArrayWithLength CoinFactorization::startRowL_`[protected]`

Start of each row in L.

Definition at line 1421 of file CoinFactorization.hpp.

Referenced by startRowL().

CoinIntArrayWithLength CoinFactorization::indexColumnL_`[protected]`

Index of column in row for L.

Definition at line 1424 of file CoinFactorization.hpp.

Referenced by indexColumnL().

CoinFactorizationDoubleArrayWithLength CoinFactorization::elementByRowL_`[protected]`

Elements in L (row copy).

Definition at line 1427 of file CoinFactorization.hpp.

Referenced by elementByRowL().

CoinIntArrayWithLength CoinFactorization::sparse_`[mutable, protected]`

Sparse regions.

Definition at line 1430 of file CoinFactorization.hpp.

int CoinFactorization::biasLU_`[protected]`

L to U bias 0 - U bias, 1 - some U bias, 2 some L bias, 3 L bias.

Definition at line 1434 of file CoinFactorization.hpp.

int CoinFactorization::persistenceFlag_`[protected]`

Array persistence flag If 0 then as now (delete/new) 1 then only do arrays if bigger needed 2 as 1 but give a bit extra if bigger needed.

Definition at line 1440 of file CoinFactorization.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Cgl-0.55.0/CoinUtils/src/CoinFactorization.hpp